
#ifndef _PC6031_DEFINED
#define _PC6031_DEFINED

#include "pc6031_avr.h"

#define	DNAMELEN	5			/* SDJ[h̃fBNg */
#define	FNAMELEN	20			/* SDJ[h̃t@CifBNg܂ށj */
#define	ENAMELEN	4			/* SDJ[h̃t@Cgq */
#if PC6031_ROM_USE
#define	DRVNUM		3			/* hCuiROMpzhCu܂ށj */
#define	DRVNUM_MUX	2			/* hCu */
#else /* PC6031_ROM_USE */
#define	DRVNUM		2			/* hCuiROMpzhCu܂ށj */
#define	DRVNUM_MUX	2			/* hCu */
#endif /* PC6031_ROM_USE */
#define	D1DIR		"D1"		/* hCu#1fBNg */
#define	D2DIR		"D2"		/* hCu#2fBNg */
#define	ROMDIR		"ROM"		/* ROMt@CfBNg */
#define	INI_FILE	"INIT"		/* t@C */
#define	FIX1D_FILE	"1D.1D"		/* 1DŒt@C */
#define	ROMDRIVE	2			/* ROMt@Ci[zhCuԍ */

typedef struct {
	BYTE	mode[DRVNUM];				/* 1D(=0)/1DD(=1) [hݒ */
	char	dname[DRVNUM][DNAMELEN];	/* fBNg */
	char	fbody[DRVNUM][FNAMELEN];	/* t@CiW{Rj */
	char	fname[DRVNUM][FNAMELEN];	/* t@CiFATFspAtpXj */
	char	fext[DRVNUM][FNAMELEN];		/* t@Cgq */
	BYTE	writep[DRVNUM];				/* CgveNg(=1) */
	BYTE	air[DRVNUM];				/* SDFlashAir */
	BYTE	airw023[DRVNUM];			/* SDFlashAir W02/W03 */
#if PC6031_ROM_USE
	char	rombody[FNAMELEN];			/* ROMt@CiWj */
#endif /* PC6031_ROM_USE */
} DISK_t;


#define	DRVNUM_ROM	0xf0		/* ROMt@Ci[zhCuԍ */

#define	EXT_P31		"P31"		/* P31gq */
#define	EXT_DSK		"DSK"		/* DSKgq */
#define	EXT_D88		"D88"		/* D88gq */
#define	EXT_ROM		"ROM"		/* ROMgq */

#define	STREAMSIZE	0x8000


BYTE IS_SD_EJECT_C(void);							/* SDJ[hꂽH */
void TIMER_START(void);								/* 5b^C}X^[g */
void P6PIO_sendw(BYTE, BYTE);						/* 1/2oCgf[^M */
void P6PIO_receivew(BYTE*, BYTE*);					/* 1/2oCgf[^M */
#if PC6031_USE_QBYTE
void P6PIO_sendq_pre(void);							/* 4oCgf[^MpO */
void P6PIO_sendq(BYTE, BYTE, BYTE, BYTE);			/* 4oCgf[^M */
void P6PIO_receiveq_pre(void);						/* 4oCgf[^MpO */
void P6PIO_receiveq(BYTE*, BYTE*, BYTE*, BYTE*);	/* 4oCgf[^M */
#endif /* PC6031_USE_QBYTE */
void P6PIO_init(void);								/* PIOݒ */
FRESULT P6PIO_SDinit(BYTE);							/* SDJ[hݒ */
void Check_FlashAir(void);							/* FlashAir`FbN */
BYTE d88_filechk(BYTE);								/* D88t@C`FbN */
BYTE is_file_wp(BYTE);								/* I𒆂̃t@CCgveNgH */
#if PC6031_ROM_USE
void sd2rom(BYTE);									/* SDSDRAMROM̈ɏ */
FRESULT sd2rom_sub(BYTE);							/* SDSDRAMROM̈ɏރTu */
#endif /* PC6031_ROM_USE */
void file_select(void);								/* t@CZN^ */
DWORD calc_offset(BYTE, DWORD, BYTE, DWORD);		/* gbNAZN^ԍAt@C̈ʒuZo */
char* get_fname(char*, char*);						/* t@C؂o */
void set_image(char*, BYTE);						/* w肵t@CC[Wt@Cɐݒ肷 */
void PC6031_main(void);								/* PC6031C[v */

#endif /* _PC6031_DEFINED */
