#ifndef _SPI_DEFINED
#define _SPI_DEFINED

#include <avr/io.h>			/* Device specific include files */
#include "pff.h"			/* include UINT/BYTE/... */

#define SD_CS_LOW()			PORTB &= ~_BV(4)	/* Set CS low */
#define	SD_CS_HIGH()		PORTB |=  _BV(4)	/* Set CS high */
#define	SD_IS_CS_LOW		!(PINB & _BV(4))	/* Test if CS is low */

void init_spi (void);		/* Initialize SPI control ports */
void xmit_spi (BYTE);		/* Send a byte to the SPI */
BYTE rcv_spi (void);		/* Send a 0xFF to the SPI and get the received byte */

#endif /* _SPI_DEFINED */
