#include <avr/io.h>			/* Device specific include files */
#include "spi.h"

/* Initialize MMC control ports */
void init_spi (void)
{
	SPCR = 0b01011100;
	SPSR = 0b00000001;		// SCK = Fosc/2
}

/* Send a byte to the MMC */
void xmit_spi (BYTE d)
{
	SPDR = d;
	while ( !(SPSR & (1<<SPIF)) ) {
		;
	}
}

/* Send a 0xFF to the MMC and get the received byte */
BYTE rcv_spi (void)
{
	SPDR = 0xff;
	while ( !(SPSR & (1<<SPIF)) ) {
		;
	}
	return SPDR;
}

